This commit is contained in:
pika 2025-03-29 21:42:33 +01:00
parent 3c19306d59
commit 88bf0bce74
2 changed files with 256 additions and 242 deletions

@ -1 +1 @@
Subproject commit 6d892008725298bb44af1ff28894d61e0eebc054 Subproject commit d7b0a20d481345198b67af46f07b668b8e5244cd

View file

@ -9,330 +9,344 @@ BOLD='\033[1m'
NC='\033[0m' # No Color NC='\033[0m' # No Color
echo_error() { echo_error() {
printf "${BOLD}${RED}ERROR: ${NC}${RED}%s${NC}\n" "$1" >&2 printf "${BOLD}${RED}ERROR: ${NC}${RED}%s${NC}\n" "$1" >&2
} }
echo_info() { echo_info() {
printf "${BOLD}${CYAN}INFO: ${NC}${CYAN}%s${NC}\n" "$1" printf "${BOLD}${CYAN}INFO: ${NC}${CYAN}%s${NC}\n" "$1"
} }
echo_warning() { echo_warning() {
printf "${BOLD}${YELLOW}WARNING: ${NC}${YELLOW}%s${NC}\n" "$1" printf "${BOLD}${YELLOW}WARNING: ${NC}${YELLOW}%s${NC}\n" "$1"
} }
echo_note() { echo_note() {
printf "${BOLD}${LIGHT_GREEN}NOTE: ${NC}${LIGHT_GREEN}%s${NC}\n" "$1" printf "${BOLD}${LIGHT_GREEN}NOTE: ${NC}${LIGHT_GREEN}%s${NC}\n" "$1"
} }
# ─< Check if the given command exists silently >───────────────────────────────────────── # ─< Check if the given command exists silently >─────────────────────────────────────────
command_exists() { command_exists() {
command -v "$@" >/dev/null 2>&1 command -v "$@" >/dev/null 2>&1
} }
# ─< Check if the user is root and set sudo variable if necessary >─────────────────────── # ─< Check if the user is root and set sudo variable if necessary >───────────────────────
check_root() { check_root() {
if ((EUID != 0)); then if ((EUID != 0)); then
if command_exists sudo; then if command_exists sudo; then
echo_info "User is not root. Using sudo for privileged operations." echo_info "User is not root. Using sudo for privileged operations."
_sudo="sudo" _sudo="sudo"
else else
echo_error "No sudo found and you're not root! Can't install packages." echo_error "No sudo found and you're not root! Can't install packages."
return 1 return 1
fi fi
else else
echo_info "Root access confirmed." echo_info "Root access confirmed."
_sudo="" _sudo=""
fi fi
} }
# ─< Distribution detection and installation >──────────────────────────────────────── # ─< Distribution detection and installation >────────────────────────────────────────
get_packager() { get_packager() {
pkger=( pkger=(
"apt" "apt"
"pacman" "pacman"
"dnf" "dnf"
"apk" "apk"
"zypper" "zypper"
) )
for pkger in "${pkger[@]}"; do for pkger in "${pkger[@]}"; do
if command_exists "$pkger"; then if command_exists "$pkger"; then
echo_info "Found package manager: $pkger" echo_info "Found package manager: $pkger"
case "$pkger" in case "$pkger" in
"apt") "apt")
$_sudo apt-get update $_sudo apt-get update
_install() { $_sudo apt-get install --assume-yes "$@"; } _install() { $_sudo apt-get install --assume-yes "$@"; }
;; ;;
"pacman") "pacman")
$_sudo pacman -Syy $_sudo pacman -Syy
_install() { $_sudo pacman -S --noconfirm "$@"; } _install() { $_sudo pacman -S --noconfirm "$@"; }
;; ;;
"dnf") "dnf")
$_sudo dnf update $_sudo dnf update
_install() { $_sudo dnf install -y "$@"; } _install() { $_sudo dnf install -y "$@"; }
;; ;;
"apk") "apk")
_install() { $_sudo apk add "$@"; } _install() { $_sudo apk add "$@"; }
;; ;;
"zypper") "zypper")
$_sudo zypper ref $_sudo zypper ref
_install() { $_sudo zypper in -y "$@"; } _install() { $_sudo zypper in -y "$@"; }
;; ;;
esac esac
fi fi
done done
} }
silentexec() { silentexec() {
"$@" >/dev/null 2>&1 "$@" >/dev/null 2>&1
} }
__pre_stow__() { __pre_stow__() {
echo_note "__pre_stow__" echo_note "__pre_stow__"
conf="$HOME/.config" conf="$HOME/.config"
bak_dir="$HOME/.bak" bak_dir="$HOME/.bak"
dirs=( dirs=(
"btop" "btop"
"gBar" "gBar"
"yazi" "yazi"
"fastfetch" "fastfetch"
"hypr" "hypr"
"kitty" "kitty"
"neovide" "neovide"
"rofi" "rofi"
"waybar" "waybar"
"wlogout" "wlogout"
"wob" "wob"
) )
if [ ! -d "$bak_dir" ]; then if [ ! -d "$bak_dir" ]; then
echo_info "backup dir created at $bak_dir" && echo_info "backup dir created at $bak_dir" &&
silentexec mkdir "$bak_dir" silentexec mkdir "$bak_dir"
else else
echo_info "Backup dir already present, clearing now" && echo_info "Backup dir already present, clearing now" &&
rm -rf "${bak_dir:?}/*" rm -rf "${bak_dir:?}/*"
fi fi
for _dirs in "${dirs[@]}"; do for _dirs in "${dirs[@]}"; do
if [ -d "$conf/$_dirs" ]; then if [ -d "$conf/$_dirs" ]; then
mv -f "$conf/$_dirs" "$bak_dir" mv -f "$conf/$_dirs" "$bak_dir"
fi fi
done done
h_files=( h_files=(
".zshrc" ".zshrc"
".zshenv" ".zshenv"
".tmux.conf" ".tmux.conf"
".wezterm.lua" ".wezterm.lua"
) )
h_dirs=( h_dirs=(
".tmux" ".tmux"
".zsh" ".zsh"
) )
for _f in "${h_files[@]}"; do for _f in "${h_files[@]}"; do
if [ -f "$HOME/$_f" ]; then if [ -f "$HOME/$_f" ]; then
mv -f "$HOME/$_f" "$bak_dir" && echo_info "Moved $_f to $bak_dir" mv -f "$HOME/$_f" "$bak_dir" && echo_info "Moved $_f to $bak_dir"
fi fi
done done
for _d in "${h_dirs[@]}"; do for _d in "${h_dirs[@]}"; do
if [ -d "$HOME/$_d" ]; then if [ -d "$HOME/$_d" ]; then
mv -f "$HOME/$_d" "$bak_dir" && echo_info "Moved $_d to $bak_dir" mv -f "$HOME/$_d" "$bak_dir" && echo_info "Moved $_d to $bak_dir"
fi fi
done done
if [ -d "$HOME/.local/share/fastfetch/" ]; then if [ -d "$HOME/.local/share/fastfetch/" ]; then
mv -f "$HOME/.local/share/fastfetch" "$bak_dir" mv -f "$HOME/.local/share/fastfetch" "$bak_dir"
fi fi
} }
askThings() { askThings() {
echo_info "Choose a menu - [r]ofi || [t]ofi" echo_info "Choose a menu - [r]ofi || [t]ofi"
read -r askMenu </dev/tty read -r askMenu </dev/tty
echo_info "Choose a cli filemanager - [y]azi || [r]anger || [l]f" echo_info "Choose a cli filemanager - [y]azi || [r]anger || [l]f"
read -r askFilemgr </dev/tty read -r askFilemgr </dev/tty
echo_info "Choose a bar provider - [w]aybar || [g]Bar || [h]yprpanel" echo_info "Choose a bar provider - [w]aybar || [g]Bar || [h]yprpanel"
read -r askBar </dev/tty read -r askBar </dev/tty
echo_info "Choose a Terminal config (.)[G]hostty, [K]itty, [A]lacritty(.)" echo_info "Choose a Terminal config (.)[G]hostty, [K]itty, [A]lacritty(.)"
read -r askTerminal </dev/tty read -r askTerminal </dev/tty
echo_info "Do you also want to install optional packages? (y/n)" echo_info "Do you also want to install optional packages? (y/n)"
read -r askOptional </dev/tty read -r askOptional </dev/tty
if [ ! -d "$HOME/.config/nvim" ]; then if [ ! -d "$HOME/.config/nvim" ]; then
echo_info "Do you also want to install a neovim config? [m]inimal || [s]tandard || [a]stro || [n]o" echo_info "Do you also want to install a neovim config? [m]inimal || [s]tandard || [a]stro || [n]o"
read -r askNvim </dev/tty read -r askNvim </dev/tty
fi fi
case "$askOptional" in case "$askOptional" in
[yY]) __optional__="true" ;; [yY]) __optional__="true" ;;
[nN]) __optional__="false" ;; [nN]) __optional__="false" ;;
esac esac
}
initNvim() {
echo_info "Do you want to init the neovim configuratin (installs plugins and lsps headlessly) (Y/n)"
read -r initNeovim </dev/tty
case "$initNeovim" in
[nN])
return 0
;;
*)
nvim --headless +q
;;
esac
} }
ask_Neovide() { ask_Neovide() {
echo_info "Do you also want to install a neovide config? [y/N]" echo_info "Do you also want to install a neovide config? [y/N]"
read -r askNeovide </dev/tty read -r askNeovide </dev/tty
case "$askNeovide" in case "$askNeovide" in
[yY]) [yY])
cloneDots "neovide" cloneDots "neovide"
;; ;;
esac esac
} }
cloneDots() { cloneDots() {
choise="$1" choise="$1"
cloneName="${2:-$1}" cloneName="${2:-$1}"
if command_exists git; then if command_exists git; then
[ -d ./dotfiles ] && [ -d ./dotfiles ] &&
[ ! -d "./dotfiles/${choise}" ] && [ ! -d "./dotfiles/${choise}" ] &&
git clone --depth=1 "https://git.k4li.de/dotfiles/${choise}.git" "./dotfiles/.config/${cloneName}" git clone --depth=1 "https://git.k4li.de/dotfiles/${choise}.git" "./dotfiles/.config/${cloneName}"
else else
echo_error "Git was not found" echo_error "Git was not found"
fi fi
} }
__validate__() { __validate__() {
if askThings; then if askThings; then
case "$askMenu" in case "$askMenu" in
[rR] | rofi) cloneDots "rofi" ;; [rR] | rofi) cloneDots "rofi" ;;
[tT] | tofi) cloneDots "tofi" ;; [tT] | tofi) cloneDots "tofi" ;;
esac esac
case "$askFilemgr" in case "$askFilemgr" in
[yY] | yazi) cloneDots "yazi" ;; [yY] | yazi) cloneDots "yazi" ;;
[rR] | ranger) cloneDots "ranger" ;; [rR] | ranger) cloneDots "ranger" ;;
[lL] | lf) cloneDots "lf" ;; [lL] | lf) cloneDots "lf" ;;
esac esac
case "$askBar" in case "$askBar" in
[wW] | waybar) cloneDots "waybar" ;; [wW] | waybar) cloneDots "waybar" ;;
[gG] | gBar | gbar) cloneDots "gBar" ;; [gG] | gBar | gbar) cloneDots "gBar" ;;
[hH] | hyprpanel) cloneDots "hyprpanel" ;; [hH] | hyprpanel) cloneDots "hyprpanel" ;;
esac esac
case "$askTerminal" in case "$askTerminal" in
[gG] | ghostty) cloneDots "ghostty" ;; [gG] | ghostty) cloneDots "ghostty" ;;
[kK] | kitty) cloneDots "kitty" ;; [kK] | kitty) cloneDots "kitty" ;;
[aA] | alacritty) cloneDots "alacritty" ;; [aA] | alacritty) cloneDots "alacritty" ;;
esac esac
case "$askNvim" in case "$askNvim" in
[sS] | standard) cloneDots "nvim" && ask_Neovide ;; [sS] | standard) cloneDots "nvim" && initNvim && ask_Neovide ;;
[mM] | minimal) cloneDots "nvim-mini" "nvim" && ask_Neovide ;; [mM] | minimal) cloneDots "nvim-mini" "nvim" && initNvim && ask_Neovide ;;
[aA] | astro) cloneDots "nvim-astro" "nvim" && ask_Neovide ;; [aA] | astro) cloneDots "nvim-astro" "nvim" && initNvim && ask_Neovide ;;
[nN] | no) return 0 ;; [nN] | no) return 0 ;;
esac esac
else else
echo_error "Something went terribly wrong" echo_error "Something went terribly wrong"
exit 1 exit 1
fi fi
} }
__dep__() { __dep__() {
_depss=( _depss=(
"stow" "stow"
"btop" "btop"
"entr" "entr"
"unzip" "unzip"
"zip" "zip"
"fzf" "fzf"
"tmux" "tmux"
"copyq" "copyq"
"rsync" "rsync"
"wezterm" "wezterm"
"wlogout" "wlogout"
"zoxide" "zoxide"
) )
for hyprdots_dependency in "${_depss[@]}"; do for hyprdots_dependency in "${_depss[@]}"; do
if ! command_exists "$hyprdots_dependency"; then if ! command_exists "$hyprdots_dependency"; then
echo_note "--- installing $hyprdots_dependency ---" echo_note "--- installing $hyprdots_dependency ---"
_install "$hyprdots_dependency" _install "$hyprdots_dependency"
else else
echo_info "$hyprdots_dependency is already installed" echo_info "$hyprdots_dependency is already installed"
fi fi
done done
} }
__monitors__() { __monitors__() {
if [ ! -e "$HOME/.monitors.conf" ]; then if [ ! -e "$HOME/.monitors.conf" ]; then
res="$(hyprctl monitors | grep -oP '\d+x\d+@\d+\.\d+' | head -n 1)" res="$(hyprctl monitors | grep -oP '\d+x\d+@\d+\.\d+' | head -n 1)"
touch "$HOME/.monitors.conf" touch "$HOME/.monitors.conf"
echo "monitor = eDP-1, ${res}, 0x0, 1" >"$HOME/.monitors.conf" echo "monitor = eDP-1, ${res}, 0x0, 1" >"$HOME/.monitors.conf"
fi fi
} }
pkg_optional() { pkg_optional() {
_ops=( _ops=(
"cowsay" "cowsay"
"cmatrix" "cmatrix"
"trash-cli" "trash-cli"
) )
case "$_ops" in case "$_ops" in
Y | y) Y | y)
for _o_ in "${_ops[@]}"; do for _o_ in "${_ops[@]}"; do
if command_exists "$_o_"; then if command_exists "$_o_"; then
echo_note "$_o_ - is already installed" echo_note "$_o_ - is already installed"
else else
echo_info "Installing $_o_" echo_info "Installing $_o_"
_install "$_o_" _install "$_o_"
fi fi
done done
;; ;;
*) *)
echo default echo default
;; ;;
esac esac
} }
__stow__() { __stow__() {
stow --verbose --target="$HOME" --defer=.gitmodules --restow */ stow --verbose --target="$HOME" --defer=.gitmodules --restow */
} }
main() { main() {
check_root check_root
get_packager get_packager
__validate__ __validate__
__dep__ __dep__
if ! command_exists stow; then if ! command_exists stow; then
echo_error "we couldn't find stow on the machine, do you want us to install it? (y/n): " echo_error "we couldn't find stow on the machine, do you want us to install it? (y/n): "
read -r ask_stow read -r ask_stow
case "$ask_stow" in case "$ask_stow" in
Y | y) Y | y)
_install stow _install stow
;; ;;
*) *)
echo_error "You cannot proceed without installing stow! Please install manually" echo_error "You cannot proceed without installing stow! Please install manually"
exit 1 exit 1
;; ;;
esac esac
else else
echo_info "stow was found, going on to prepare to stow your config" echo_info "stow was found, going on to prepare to stow your config"
sleep 0.3 sleep 0.3
fi fi
__pre_stow__ __pre_stow__
__stow__ __stow__
sleep 2 sleep 2
[ "$__optional__" = "true" ] && [ "$__optional__" = "true" ] &&
pkg_optional pkg_optional
__monitors__ __monitors__
echo_note "found resolution ${res}" echo_note "found resolution ${res}"
} }
main main